<html><head><title>Solar System logging</title>
<meta http-equiv='refresh' content='10'>
</head><body>

<?php
//Written by Wade Elmore 
//Written for RaspberryPi running Jessie OS and Apache and PHP
//Questions, comments and suggestions welcome via email to wade_elmore@comcast.net
//This text, code and /or program(s) is intended for non commerical use.  It free ware.
//This text, code and /or program(s) is offered without warranty of any kind.
//Use this text, code and /or program(s) at your own risk.
//Revised 1710242216


//This program requires Modbus files IecType.php, ModbusMaster.php, ModbusMasterTcp.php, ModbusMasterUdp.php,PhpType.php,
// and ClassicNames.php. These files must be located in the same directory as this program.
//This program uses TCP Modbus to read selected registers from two Classic 150s and creates a log file of the selected
//  registers and a 'current.txt' file that is used by the Solor_Monitoring page.


$dir = "Data/"; //Location of data files, as viewed from this file's location.
$cr = "\n";
$Tags = "";
$Tag = date("Ymd"); 

echo ("<H1>Keep this open and running.</h1> Last update was at ".date("M d, Y Hi:s"));
echo ("</br>");

require_once dirname(__FILE__) . '/ModbusMaster.php';
require_once dirname(__FILE__) . '/ClassicNames.php';

$Solar1= "192.168.0.121";
$Solar2= "192.168.0.122";



$ClassicData[50];
$ClassicData[0] = date("His");
$Dlog_Data[17];

$inx=1;

function regdata($reg, $count, $recData,$modbus){
	global $classicheading, $inx, $ClassicData, $classicchargestate, $AUX1, $AUX2, $AUXstate ;
	try {
    	// FC 3
    		$recData = $modbus->readMultipleRegisters(0, $reg - 1, $count);
	}
	catch (Exception $e) {
    		// Print error information if any
		//   echo $modbus;  //prints raw data
   		echo $e;
    		//exit;
	}
	for ($a = 0; $a <= (($count*2-1)); $a++){
		if (strlen($classicheading[($reg-4100)]) > 0or $reg == 4130 or $reg == 4165){
			echo ($inx);
			echo ("  ");
			echo ($reg);
			echo ("  ");
			echo ($classicheading[($reg-4100)]);
			echo ("  ");
			if($reg == 4115 or $reg == 4116 or $reg == 4117 or $reg == 4118 or $reg == 4121 or $reg == 4122){
				$ClassicData[$inx] =((($recData[$a]*256)+$recData[$a+1])/10);
				$inx++;
				
			}
			if($reg == 4120){
				$ClassicData[$inx] =($classicchargestate[$recData[$a]]);
				$inx++;
			}	
			if($reg == 4119 or  $reg == 4125   or $reg == 4138 or $reg == 4139 or $reg == 4143 or $reg == 4154 or $reg == 4162 or $reg == 4365 or $reg == 4376 or $reg == 4377 or $reg == 4381){
				$ClassicData[$inx] =((($recData[$a]*256)+$recData[$a+1]));
				$inx++;
			}
			if($reg == 4126 or $reg == 4128){
				$ClassicData[$inx] =((((($recData[$a+2]*256)+$recData[$a+3])*256)+($recData[$a]*256)+$recData[$a+1])/10);
				$inx++;
			}
			if ($reg == 4132 or $reg == 4133 or $reg == 4134){
				$ClassicData[$inx] =((($recData[$a]*256 +$recData[$a+1])/10)*1.8+32);
				$inx++;
			}
			
			if($reg == 4369 or $reg == 4371 ){
				if (($recData[$a]*256)+$recData[$a+1] >= 0x8000){
					$ClassicData[$inx] =((($recData[$a]*256)+$recData[$a+1]-0xffff)/10);
				}else{
					$ClassicData[$inx] =((($recData[$a]*256)+$recData[$a+1])/10);
				}
				$inx++;
			}
			if($reg == 4367){
				$ClassicData[$inx] =((($recData[$a]*256)+$recData[$a+1]-0x10000));
				$inx++;
			}
			if($reg == 4372){
				$ClassicData[$inx] =(($recData[$a+1]-50)*1.8 +32);
				$inx++;
			}		
			if($reg == 4165){
				//AUX states
				$AX[2]=$AUX1[($recData[$a+1] &0x3f)];
				$AX[3]=$AUXstate[($recData[$a+1] &0xc0)/64];
				$AX[4]=$AUX2[($recData[$a] &0x3f)];
				$AX[5]=$AUXstate[($recData[$a] &0xc0)/64];
				
				echo ('<br>AUX 1 = '.$AX[2].'  '.$AX[3].'  '.$AX[0].'<br>');
				echo ('AUX 2 = '.$AX[4].'  '.$AX[5].'  '.$AX[1].'<br>');
				}
			if ($reg == 4130){
				if (($recData[$a] &0x40) == true){
					$AX[0]="On";
				}else{
					$AX[0]='Off';		
				}
				if (($recData[$a] &0x80) == true){
					$AX[1]="On";
				}else{
					$AX[1]='Off';		
				}				

			}
			if ($reg != 4165){
				echo ($ClassicData[$inx-1]);
			}
			echo ("<br>");
		}
	$a++;
	$reg++;
	
	}
	echo ("<br>");
	return $AX;
}
echo ('Solar 1 PV<br>');
$start = 4115;
$count = 51;


// IP4 address of first Classic.  This Classic has a WizBang connected to monitor battery current.
$modbus = new ModbusMaster($Solar1, "TCP");
$AX1=regdata($start, $count, $recData, $modbus);

echo ('Solar 1 Battery<br>');
$start = 4364;
$count = 20;
regdata($start, $count, $recData, $modbus);

echo ('Solar 2 PV<br>');
$start = 4115;
$count = 51;

//IP4 address of second Classic
$modbus = new ModbusMaster($Solar2, "TCP");
$AX2=regdata($start, $count, $recData, $modbus);

//save data to daily detailed log file

$Tagf = fopen ($dir.$Tag.".txt","a");
	umask(0777);
	fputcsv($Tagf,$ClassicData);
	fputcsv($Tagf,$AX1);
	fputcsv($Tagf,$AX2);
	fputcsv($Tagf,$Dlog_Data);	
fclose($Tagf);


//Recall old Dlog_Data  Daily high / low and Ahr consumed information.
$Tagf = fopen ($dir."current.txt","r");
	$Dlog_Data = fgetcsv($Tagf);
fclose($Tagf);
//$Tag="";
if ($Dlog_Data[0] != $Tag){
	$Tagf = fopen ($dir."Solar_log.dat","a");
	umask(0777);
	fputcsv($Tagf,$Dlog_Data);
	fclose($Tagf);
	$Dlog_Data[0] = $Tag;	
	$Dlog_Data[1] = $ClassicData[26]; // Start of day capacity
	$Dlog_Data[3] = 0;
	$Dlog_Data[4] = 0;
	$Dlog_Data[5] = 0;
	$Dlog_Data[6] = 0;
	$Dlog_Data[7] = 0;
	$Dlog_Data[8] = 0;
	$Dlog_Data[9] = 100;
	$Dlog_Data[10] = 0;
	$Dlog_Data[11] = 0;
	$Dlog_Data[12] = 0;
	$Dlog_Data[13] = 0;
	$Dlog_Data[14] = 0;
	$Dlog_Data[15] = 0;
	$Dlog_Data[16] = 100;
	$Dlog_Data[17] = 0;
echo("Start new daily records<BR>");
}	

//Build Dlog_Data
$Dlog_Data[2] = $ClassicData[26]; //current capacity
if ($ClassicData[5] >= $Dlog_Data[3]){
	$Dlog_Data[3] = $ClassicData[5]; //S1 Peak Watts today
}
if ($ClassicData[32] >= $Dlog_Data[4]){
	$Dlog_Data[4] = $ClassicData[32]; //S2 Peak Watts today
}
if ($ClassicData[4] >= $Dlog_Data[5]){
	$Dlog_Data[5] = $ClassicData[4]; //S1 kWhr today
}
if ($ClassicData[31] >= $Dlog_Data[6]){
	$Dlog_Data[6] = $ClassicData[31]; //S2 kWhr today
}
if ($ClassicData[9] >= $Dlog_Data[7]){
	$Dlog_Data[7] = $ClassicData[9]; //S1 Ahr today
}
if ($ClassicData[36] >= $Dlog_Data[8]){
	$Dlog_Data[8] = $ClassicData[36]; //S2 Ahr today
}
if ($ClassicData[1] <= $Dlog_Data[9]){
	$Dlog_Data[9] = $ClassicData[1]; //Low battery voltage
}
if ($ClassicData[15] >= $Dlog_Data[10]){
	$Dlog_Data[10] = $ClassicData[15]; //S1 Float
}
if ($ClassicData[42] >= $Dlog_Data[11]){
	$Dlog_Data[11] = $ClassicData[42]; //S2 Float
}
if (($ClassicData[18]-$ClassicData[16]) >= $Dlog_Data[12]){
	$Dlog_Data[12] = ($ClassicData[18]-$ClassicData[16]); //S1 Absorb
}
if (($ClassicData[45]-$ClassicData[43]) >= $Dlog_Data[13]){
	$Dlog_Data[13] = ($ClassicData[45]-$ClassicData[43]); //S2 Absorb
}

if (($ClassicData[19]-$ClassicData[17]) >= $Dlog_Data[14]){
	$Dlog_Data[14] = ($ClassicData[19]-$ClassicData[17]); //S1 Eq
}
if (($ClassicData[46]-$ClassicData[44]) >= $Dlog_Data[15]){
	$Dlog_Data[15] = ($ClassicData[46]-$ClassicData[44]); //S2 Eq
}
if ((100*$ClassicData[26]/$ClassicData[27] )<= $Dlog_Data[16]){
	$Dlog_Data[16] = (100*$ClassicData[26]/$ClassicData[27] ); //Low Charge
}
if ((100*$ClassicData[26]/$ClassicData[27] )>= $Dlog_Data[17]){
	$Dlog_Data[17] = (100*$ClassicData[26]/$ClassicData[27] ); //High Charge
}

//save data to current file if Battery is >= 10 volts. 
//   Sometimes the Classic is busy and returns all zeros for the registers.
//   This prevents the zero data from being saved as low data.

if ($ClassicData[1] >= 10 and $ClassicData[28] >= 10){
	$Tagf = fopen ($dir."current.txt","w");
	fputcsv($Tagf,$Dlog_Data);
	fputcsv($Tagf,$ClassicData);
	fputcsv($Tagf,$AX1);
	fputcsv($Tagf,$AX2);	
	fclose($Tagf);
}
//Display Dlog_Data
for ($a = 0; $a <= 17 ;$a++){
	echo ($a.'  '.$Daily_log_name[$a].'  '.$Dlog_Data[$a].'<br>');
}

?>
</body></html>


